/*
 * calculator.l - for xdata
 * To compile: make calculator
 *  yacc -d calculator.y
 *  flex calculator.l
 *  cc -x c++ -o calculator y.tab.c lex.yy.c -ll -lm
 */
%{
#include "y.tab.h"
#include <math.h>
#include <string.h>
#include "xdata.h"
extern int lineno, col;
extern Globals  g;
extern Spreadsheet s;
struct symtab* symlook(char *s);
%}
%%
x    { return X; }
y    { return COL; }
y[0-9]+  { 
     g.cc = atoi(yytext+1);
     return Y; 
     }
([0-9\.]+|([0-9]+\.*[0-9]*)?([eE][-+]?[0-9]+)?) {
     yylval.dval = atof(yytext);
     return NUMBER;
     }
[ \t\n{}]                       /* ignore whitespace     */
">=" { return GE; }
"<=" { return LE; }
"==" { return EQ; }
if   { return IF; }
then { return THEN; }
else { return ELSE; }
"&&" { return LOGICAL_AND; }
"||" { return LOGICAL_OR; }
"+=" { return PLUS_EQUALS; }
"-=" { return MINUS_EQUALS; }
"*=" { return TIMES_EQUALS; }
"/=" { return DIVIDE_EQUALS; }
"++" { return INCREMENT; }
"--" { return DECREMENT; }
[A-Za-z][A-Za-z0-9_]* {        /* return symbol pointer */
    struct symtab *sp = symlook(yytext);
    yylval.symp = sp;
    return NAME;
    }
"$" {return 0; }              /* end of input          */
;  { lineno++; return yytext[0]; }/* end of line       */
.  return yytext[0];          /* anything else         */
%%
